#!/usr/bin/env node
import { CUSTOM_TEMPLATE_NAME as j } from "./utils/const.mjs";
import { projectNameForm as E, templateForm as S, templateChoices as x, saveGitHistoryForm as k, shallowCloneForm as F } from "./utils/question.mjs";
import n from "prompts";
import { execSync as a } from "node:child_process";
import { existsSync as p, rmSync as i, readFileSync as g, writeFileSync as f } from "node:fs";
import { resolve as M } from "node:path";
import t from "chalk";
const b = async (u) => {
  const {
    projectName: d,
    template: w,
    saveGitHistory: y,
    shallowClone: $
  } = u, r = ((d ?? (await n(E)).projectName) || "").trim();
  if (!r.trim()) {
    console.log(t.red("项目名称不能为空"));
    return;
  }
  if (r.includes(" ") || r.includes("\\") || r.includes("/")) {
    console.log(t.red("项目名称不能包含空格或者\\或者/"));
    return;
  }
  const e = M(process.cwd(), r);
  if (p(e)) {
    const { isRemove: o } = await n({
      type: "confirm",
      name: "isRemove",
      message: "项目已存在，是否删除"
    });
    if (o === !0)
      i(e, { recursive: !0, force: !0 });
    else
      return console.log(t.red("项目已存在")), process.exit(1);
  }
  const s = w ?? (await n(S)).template;
  let l = "";
  if (s === j) {
    const { customUrl: o } = await n({
      type: "text",
      name: "customUrl",
      message: "请输入自定义模板路径"
    });
    l = o;
  } else {
    const o = x.find((C) => C.name === s);
    if (!o)
      return console.log(t.red(`模板${s}不存在`)), process.exit(1);
    if (!o.url)
      return console.log(t.red(`模板${s}仓库地址不存在`)), process.exit(1);
    l = o.url;
  }
  console.log(t.green("正在初始化项目，请稍等...")), a(`git clone ${l} ${r} --depth=1`);
  const m = y ?? (await n(k)).saveGitHistory;
  if (m === !1) {
    const o = `${e}/.git`;
    if (!p(o))
      throw new Error("git目录不存在");
    i(`${e}/.git`, { recursive: !0, force: !0 });
  } else
    a(`cd ${e} && git remote rename origin upstream`);
  const h = g(`${e}/package.json`, "utf-8"), c = JSON.parse(h), { name: N } = c;
  c.name = r, i(`${e}/package.json`), f(
    `${e}/package.json`,
    JSON.stringify(c, null, 2)
  );
  const v = g(`${e}/README.md`, "utf-8").replace(N, r);
  i(`${e}/README.md`), f(`${e}/README.md`, v), console.log(t.green("项目初始化完成")), m && (($ ? (await n(F)).shallowClone : !1) ? console.log(
    t.yellow("当前使用浅克隆，后续不能与模板git仓库有完整的交互")
  ) : (a(`cd ${e} && git fetch --unshallow`), console.log(
    t.green("已完整克隆项目，后续可以与模板git仓库有完整的交互")
  ))), console.log(
    t.blue(`
使用步骤: 
  1. cd ${r}
  2. pnpm install
  3. pnpm run dev
  `)
  );
};
export {
  b as handler
};
